Index: .gitignore
===================================================================
--- .gitignore	(revision de18326f12c18fd92f275bf46bca509343b79063)
+++ .gitignore	(revision 7d03c8d7261007b87c9466976c6efd8e1a572d76)
@@ -35,3 +35,4 @@
 pm_to_blib
 stamp-h1
+tester
 varstubs.c
Index: Makefile.am
===================================================================
--- Makefile.am	(revision 9d27ee8678625706f5eead430bbe2f956fc1eb41)
+++ Makefile.am	(revision ea7daa88a058dbbe1dfd9aa2f138f80d030b2f9c)
@@ -12,5 +12,5 @@
 zcrypt_SOURCES = zcrypt.c filterproc.c
 
-check_PROGRAMS = tester.bin
+check_PROGRAMS = tester perl_tester
 
 barnowl_bin_SOURCES = $(BASE_SRCS) \
@@ -19,15 +19,19 @@
      $(GEN_C) $(GEN_H)
 
-man_MANS = doc/barnowl.1
-doc_DATA = doc/intro.txt doc/advanced.txt
-
 barnowl_bin_LDADD = libfaim/libfaim.a
 
-tester_bin_SOURCES = $(BASE_SRCS) \
+tester_SOURCES = $(BASE_SRCS) \
      owl.h owl_perl.h config.h \
      $(GEN_C) $(GEN_H) \
      tester.c
 
-tester_bin_LDADD = libfaim/libfaim.a
+tester_LDADD = libfaim/libfaim.a
+
+perl_tester_SOURCES = $(BASE_SRCS) \
+     owl.h owl_perl.h config.h \
+     $(GEN_C) $(GEN_H) \
+     perl_tester.c
+
+perl_tester_LDADD = libfaim/libfaim.a
 
 TESTS=runtests.sh
Index: README
===================================================================
--- README	(revision aeadc748f353cd0be4ebfa805d85577c9c7498fa)
+++ README	(revision 62c91c1f0cea6cc5450131f07cc577f8d54ba828)
@@ -1,7 +1,8 @@
 BarnOwl - owl, with more ponies
 
-Source is freely available from http://github.com/barnowl/barnowl/
+Based on owl 2.1.11, by James Kretchmar (http://www.ktools.org)
 
-Based on owl 2.1.11, by James Kretchmar (http://www.ktools.org)
+This project is a work in progress.
+We guarantee no stability of form or function.
 
 Notes:
Index: barnowl
===================================================================
--- barnowl	(revision de18326f12c18fd92f275bf46bca509343b79063)
+++ barnowl	(revision 9a7b4f23cba7fc71c4e918b5cb8d5ca6789924e3)
@@ -5,5 +5,5 @@
 
 SRCDIR=`dirname "${0}"`
-EXE="$0.bin"
+EXE="$SRCDIR/barnowl.bin"
 
 if ! test -x "$EXE"; then
Index: cmd.c
===================================================================
--- cmd.c	(revision 1cc9b61526eafe04cf53d24712f11ab9ac0fbb8b)
+++ cmd.c	(revision ea7daa88a058dbbe1dfd9aa2f138f80d030b2f9c)
@@ -52,5 +52,4 @@
   cmd = owl_malloc(sizeof(owl_cmd));
   owl_cmd_create_alias(cmd, alias_from, alias_to);
-  owl_perlconfig_new_command(cmd->name);
   owl_dict_insert_element(cd, cmd->name, cmd, (void (*)(void *))owl_cmd_delete);
   return(0);
Index: commands.c
===================================================================
--- commands.c	(revision 987cf3f48057443b84ecf140854129cf1a6cbbdc)
+++ commands.c	(revision 9bd51b890ba8f6556ae6e426719decbdd39c1a0e)
@@ -136,5 +136,5 @@
 	      "Send a local message.\n"),
 
-  OWLCMD_ARGS("zcrypt", owl_command_zwrite, OWL_CTX_INTERACTIVE,
+  OWLCMD_ARGS("zcrypt", owl_command_zcrypt, OWL_CTX_INTERACTIVE,
 	      "send an encrypted zephyr",
 	      "zcrypt [-n] [-C] [-c class] [-i instance] [-r realm] [-O opcode] [-m <message...>]\n",
@@ -1911,5 +1911,5 @@
 char *owl_command_zwrite(int argc, const char *const *argv, const char *buff)
 {
-  owl_zwrite *z;
+  owl_zwrite z;
 
   if (!owl_global_is_havezephyr(&g)) {
@@ -1918,21 +1918,16 @@
   }
   /* check for a zwrite -m */
-  z = owl_zwrite_new(buff);
-  if (!z) {
-    owl_function_error("Error in zwrite arguments");
-    return NULL;
-  }
-
-  if (owl_zwrite_is_message_set(z)) {
-    owl_function_zwrite(z, NULL);
-    owl_zwrite_delete(z);
-    return NULL;
-  }
+  owl_zwrite_create_from_line(&z, buff);
+  if (owl_zwrite_is_message_set(&z)) {
+    owl_function_zwrite(buff, NULL);
+    owl_zwrite_cleanup(&z);
+    return (NULL);
+  }
+  owl_zwrite_cleanup(&z);
 
   if (argc < 2) {
-    owl_zwrite_delete(z);
     owl_function_makemsg("Not enough arguments to the zwrite command.");
   } else {
-    owl_function_zwrite_setup(z);
+    owl_function_zwrite_setup(buff);
   }
   return(NULL);
@@ -2021,4 +2016,29 @@
 {
   owl_function_loopwrite_setup();
+  return(NULL);
+}
+
+char *owl_command_zcrypt(int argc, const char *const *argv, const char *buff)
+{
+  owl_zwrite z;
+
+  if (!owl_global_is_havezephyr(&g)) {
+    owl_function_makemsg("Zephyr is not available");
+    return(NULL);
+  }
+  /* check for a zcrypt -m */
+  owl_zwrite_create_from_line(&z, buff);
+  if (owl_zwrite_is_message_set(&z)) {
+    owl_function_zcrypt(buff, NULL);
+    owl_zwrite_cleanup(&z);
+    return (NULL);
+  }
+  owl_zwrite_cleanup(&z);
+
+  if (argc < 2) {
+    owl_function_makemsg("Not enough arguments to the zcrypt command.");
+  } else {
+    owl_function_zwrite_setup(buff);
+  }
   return(NULL);
 }
Index: configure.ac
===================================================================
--- configure.ac	(revision 04af908ca44749f771ae778a21315327b6d24135)
+++ configure.ac	(revision 4751077a418abe91a3ec075bb9d4c03c1310e1bc)
@@ -35,24 +35,17 @@
   [with_zephyr=check])
 
-AC_ARG_WITH([krb4],
-  AS_HELP_STRING([--with-krb4],
-                 [Build with kerberos IV]))
-
 AS_IF([test "x$with_zephyr" != xno],
-  [AS_IF([test "x$with_krb4" != "xno"],
-   [AC_MSG_CHECKING([for Kerberos IV])
-    AS_IF([krb5-config krb4 --libs >/dev/null 2>&1],
-      [AC_MSG_RESULT([yes])
-       AC_DEFINE([HAVE_KERBEROS_IV], [1], [Define if you have kerberos IV])
-       CFLAGS="${CFLAGS} `krb5-config krb4 --cflags`"
-       LIBS="${LIBS} `krb5-config krb4 --libs`"
-      ],
-      [AC_MSG_RESULT([no])
-       AS_IF([test "x$with_krb4" = "xyes"],
-             [AC_MSG_ERROR([Kerberos IV requested but not found])])
-       PKG_CHECK_MODULES([LIBCRYPTO], [libcrypto])
-       CFLAGS="${CFLAGS} ${LIBCRYPTO_CFLAGS}"
-       LIBS="${LIBS} ${LIBCRYPTO_LIBS}"
-     ])])
+  [AC_MSG_CHECKING([for Kerberos IV])
+   AS_IF([krb5-config krb4 --libs >/dev/null 2>&1],
+     [AC_MSG_RESULT([yes])
+      AC_DEFINE([HAVE_KERBEROS_IV], [1], [Define if you have kerberos IV])
+      CFLAGS="${CFLAGS} `krb5-config krb4 --cflags`"
+      LIBS="${LIBS} `krb5-config krb4 --libs`"
+     ],
+     [AC_MSG_RESULT([no])
+      PKG_CHECK_MODULES([LIBCRYPTO], [libcrypto])
+      CFLAGS="${CFLAGS} ${LIBCRYPTO_CFLAGS}"
+      LIBS="${LIBS} ${LIBCRYPTO_LIBS}"
+     ])
    AC_CHECK_LIB([zephyr], [ZGetSender],
    [LIBS="$LIBS -lzephyr"
@@ -138,6 +131,4 @@
                                  test "$HAVE_DES_ECB_ENCRYPT"])
 
-CFLAGS="$CFLAGS -D_XOPEN_SOURCE"
-
 AC_SUBST([LIBFAIM_CFLAGS])
 
Index: functions.c
===================================================================
--- functions.c	(revision 8bba1aed9c99b38e86fab76c25d3b415be31afdb)
+++ functions.c	(revision 8bba1aed9c99b38e86fab76c25d3b415be31afdb)
@@ -222,11 +222,17 @@
  * that.
  */
-owl_message *owl_function_make_outgoing_zephyr(const owl_zwrite *z)
+owl_message *owl_function_make_outgoing_zephyr(const char *body, const char *zwriteline, const char *zsig)
 {
   owl_message *m;
+  owl_zwrite zw;
+
+  owl_zwrite_create_from_line(&zw, zwriteline);
+  owl_zwrite_set_zsig(&zw, zsig);
 
   /* create the message */
   m=owl_malloc(sizeof(owl_message));
-  owl_message_create_from_zwrite(m, z, owl_zwrite_get_message(z));
+  
+  owl_message_create_from_zwrite(m, &zw, body);
+  owl_zwrite_cleanup(&zw);
 
   return(m);
@@ -289,5 +295,5 @@
 }
 
-static void owl_function_write_setup(const char *noun)
+static void owl_function_write_setup(const char *line, const char *noun, void (*callback)(owl_editwin *))
 {
 
@@ -300,41 +306,46 @@
 			 "End with a dot on a line by itself.  ^C will quit.",
 			 noun);
-}
-
-void owl_function_zwrite_setup(owl_zwrite *z)
-{
+
+  owl_function_start_edit_win(line, callback,
+                              owl_strdup(line),
+                              owl_free);
+}
+
+void owl_function_zwrite_setup(const char *line)
+{
+  owl_zwrite z;
+  int ret;
+
+  /* check the arguments */
+  ret=owl_zwrite_create_from_line(&z, line);
+  if (ret) {
+    owl_function_error("Error in zwrite arguments");
+    owl_zwrite_cleanup(&z);
+    return;
+  }
+
   /* send a ping if necessary */
   if (owl_global_is_txping(&g)) {
-    owl_zwrite_send_ping(z);
-  }
-
-
-  owl_function_write_setup("zephyr");
-  owl_function_start_edit_win(z->zwriteline,
-                              &owl_callback_zwrite,
-                              z, (void(*)(void*))owl_zwrite_delete);
+    owl_zwrite_send_ping(&z);
+  }
+  owl_zwrite_cleanup(&z);
+
+  owl_function_write_setup(line, "zephyr", &owl_callback_zwrite);
 }
 
 void owl_function_aimwrite_setup(const char *line)
 {
-  owl_function_write_setup("message");
-  owl_function_start_edit_win(line,
-                              &owl_callback_aimwrite,
-                              owl_strdup(line),
-                              owl_free);
-
+  owl_function_write_setup(line, "message", &owl_callback_aimwrite);
 }
 
 void owl_function_loopwrite_setup(void)
 {
-  owl_function_write_setup("message");
-  owl_function_start_edit_win("loopwrite",
-                              &owl_callback_loopwrite,
-                              "loopwrite", NULL);
+  owl_function_write_setup("loopwrite", "message", owl_callback_loopwrite);
 }
 
 void owl_callback_zwrite(owl_editwin *e) {
-  owl_zwrite *z = owl_editwin_get_cbdata(e);
-  owl_function_zwrite(z, owl_editwin_get_text(e));
+  char *command = owl_editwin_get_cbdata(e);
+  owl_function_zwrite(command,
+                      owl_editwin_get_text(e));
 }
 
@@ -342,25 +353,29 @@
  * the message is expected to be set from the zwrite line itself
  */
-void owl_function_zwrite(owl_zwrite *z, const char *msg)
-{
+void owl_function_zwrite(const char *line, const char *msg)
+{
+  owl_zwrite z;
+  const char *mymsg;
   owl_message *m;
 
-  if(strcmp(z->cmd, "zcrypt") == 0) {
-    owl_function_zcrypt(z, msg);
+  if(!strncmp(line, "zcrypt", strlen("zcrypt"))) {
+    owl_function_zcrypt(line, msg);
     return;
   }
 
   /* create the zwrite and send the message */
-  owl_zwrite_populate_zsig(z);
+  owl_zwrite_create_from_line(&z, line);
+  owl_zwrite_populate_zsig(&z);
   if (msg) {
-    owl_zwrite_set_message(z, msg);
-  }
-  owl_zwrite_send_message(z);
+    owl_zwrite_set_message(&z, msg);
+  }
+  owl_zwrite_send_message(&z);
   owl_function_makemsg("Waiting for ack...");
 
   /* If it's personal */
-  if (owl_zwrite_is_personal(z)) {
+  if (owl_zwrite_is_personal(&z)) {
     /* create the outgoing message */
-    m=owl_function_make_outgoing_zephyr(z);
+    mymsg=owl_zwrite_get_message(&z);
+    m=owl_function_make_outgoing_zephyr(mymsg, line, owl_zwrite_get_zsig(&z));
 
     if (m) {
@@ -370,4 +385,7 @@
     }
   }
+
+  /* free the zwrite */
+  owl_zwrite_cleanup(&z);
 }
 
@@ -375,6 +393,8 @@
  * the message is expected to be set from the zwrite line itself
  */
-void owl_function_zcrypt(owl_zwrite *z, const char *msg)
-{
+void owl_function_zcrypt(const char *line, const char *msg)
+{
+  owl_zwrite z;
+  const char *mymsg;
   char *cryptmsg;
   owl_message *m;
@@ -382,21 +402,22 @@
   char *zcrypt;
   int rv, status;
-  char *old_msg;
 
   /* create the zwrite and send the message */
-  owl_zwrite_populate_zsig(z);
+  owl_zwrite_create_from_line(&z, line);
+  owl_zwrite_populate_zsig(&z);
   if (msg) {
-    owl_zwrite_set_message(z, msg);
-  }
-  old_msg = owl_strdup(owl_zwrite_get_message(z));
+    owl_zwrite_set_message(&z, msg);
+  }
+
+  mymsg=owl_zwrite_get_message(&z);
 
   zcrypt = owl_sprintf("%s/zcrypt", owl_get_bindir());
   argv[0] = "zcrypt";
   argv[1] = "-E";
-  argv[2] = "-c"; argv[3] = owl_zwrite_get_class(z);
-  argv[4] = "-i"; argv[5] = owl_zwrite_get_instance(z);
+  argv[2] = "-c"; argv[3] = owl_zwrite_get_class(&z);
+  argv[4] = "-i"; argv[5] = owl_zwrite_get_instance(&z);
   argv[6] = NULL;
 
-  rv = call_filter(zcrypt, argv, owl_zwrite_get_message(z), &cryptmsg, &status);
+  rv = call_filter(zcrypt, argv, mymsg, &cryptmsg, &status);
 
   owl_free(zcrypt);
@@ -404,21 +425,21 @@
   if (rv || status) {
     if(cryptmsg) owl_free(cryptmsg);
-    owl_free(old_msg);
     owl_function_error("Error in zcrypt, possibly no key found.  Message not sent.");
     owl_function_beep();
+    owl_zwrite_cleanup(&z);
     return;
   }
 
-  owl_zwrite_set_message_raw(z, cryptmsg);
-  owl_zwrite_set_opcode(z, "crypt");
-
-  owl_zwrite_send_message(z);
+  owl_zwrite_set_message(&z, cryptmsg);
+  owl_zwrite_set_opcode(&z, "crypt");
+    
+  owl_zwrite_send_message(&z);
   owl_function_makemsg("Waiting for ack...");
 
   /* If it's personal */
-  if (owl_zwrite_is_personal(z)) {
-    /* Create the outgoing message. Restore the un-crypted message for display. */
-    owl_zwrite_set_message_raw(z, old_msg);
-    m=owl_function_make_outgoing_zephyr(z);
+  if (owl_zwrite_is_personal(&z)) {
+    /* create the outgoing message */
+    mymsg=owl_zwrite_get_message(&z);
+    m=owl_function_make_outgoing_zephyr(mymsg, line, owl_zwrite_get_zsig(&z));
     if (m) {
       owl_global_messagequeue_addmsg(&g, m);
@@ -430,4 +451,5 @@
   /* free the zwrite */
   owl_free(cryptmsg);
+  owl_zwrite_cleanup(&z);
 }
 
Index: global.c
===================================================================
--- global.c	(revision 8bba1aed9c99b38e86fab76c25d3b415be31afdb)
+++ global.c	(revision 8bba1aed9c99b38e86fab76c25d3b415be31afdb)
@@ -19,4 +19,7 @@
   char hostname[MAXHOSTNAMELEN];
   char *cd;
+
+  g->malloced=0;
+  g->freed=0;
 
   g_type_init();
@@ -952,33 +955,2 @@
   g->interrupted = 0;
 }
-
-void owl_global_setup_default_filters(owl_global *g)
-{
-  int i;
-  static const struct {
-    const char *name;
-    const char *desc;
-  } filters[] = {
-    { "personal",
-      "isprivate ^true$ and ( not type ^zephyr$ or ( class ^message  ) )" },
-    { "trash",
-      "class ^mail$ or opcode ^ping$ or type ^admin$ or ( not login ^none$ )" },
-    { "wordwrap", "not ( type ^admin$ or type ^zephyr$ )" },
-    { "ping", "opcode ^ping$" },
-    { "auto", "opcode ^auto$" },
-    { "login", "not login ^none$" },
-    { "reply-lockout", "class ^noc or class ^mail$" },
-    { "out", "direction ^out$" },
-    { "aim", "type ^aim$" },
-    { "zephyr", "type ^zephyr$" },
-    { "none", "false" },
-    { "all", "true" },
-    { NULL, NULL }
-  };
-
-  owl_function_debugmsg("startup: creating default filters");
-
-  for (i = 0; filters[i].name != NULL; i++)
-    owl_global_add_filter(g, owl_filter_new_fromstring(filters[i].name,
-                                                       filters[i].desc));
-}
Index: owl.c
===================================================================
--- owl.c	(revision 0be3efd03a33482174f56f64de8d3412b9ecb783)
+++ owl.c	(revision 0be3efd03a33482174f56f64de8d3412b9ecb783)
@@ -149,4 +149,34 @@
 }
 
+static void owl_setup_default_filters(void)
+{
+  int i;
+  static const struct {
+    const char *name;
+    const char *desc;
+  } filters[] = {
+    { "personal",
+      "isprivate ^true$ and ( not type ^zephyr$ or ( class ^message  ) )" },
+    { "trash",
+      "class ^mail$ or opcode ^ping$ or type ^admin$ or ( not login ^none$ )" },
+    { "wordwrap", "not ( type ^admin$ or type ^zephyr$ )" },
+    { "ping", "opcode ^ping$" },
+    { "auto", "opcode ^auto$" },
+    { "login", "not login ^none$" },
+    { "reply-lockout", "class ^noc or class ^mail$" },
+    { "out", "direction ^out$" },
+    { "aim", "type ^aim$" },
+    { "zephyr", "type ^zephyr$" },
+    { "none", "false" },
+    { "all", "true" },
+    { NULL, NULL }
+  };
+
+  owl_function_debugmsg("startup: creating default filters");
+
+  for (i = 0; filters[i].name != NULL; i++)
+    owl_global_add_filter(&g, owl_filter_new_fromstring(filters[i].name,
+                                                        filters[i].desc));
+}
 
 /*
@@ -514,5 +544,5 @@
   owl_global_complete_setup(&g);
 
-  owl_global_setup_default_filters(&g);
+  owl_setup_default_filters();
 
   /* set the current view */
Index: owl.h
===================================================================
--- owl.h	(revision 987cf3f48057443b84ecf140854129cf1a6cbbdc)
+++ owl.h	(revision 5cc7e5e45702da552c2ba2d3eb236eaeca359eb4)
@@ -347,5 +347,4 @@
 
 typedef struct _owl_zwrite {
-  char *cmd;
   char *zwriteline;
   char *class;
@@ -614,4 +613,5 @@
   owl_colorpair_mgr cpmgr;
   pid_t newmsgproc_pid;
+  int malloced, freed;
   owl_regex search_re;
   aim_session_t aimsess;
Index: perl/modules/Jabber/lib/BarnOwl/Message/Jabber.pm
===================================================================
--- perl/modules/Jabber/lib/BarnOwl/Message/Jabber.pm	(revision 2f25537acb67e620a5be5052f5c2f9a1e5fe3abd)
+++ perl/modules/Jabber/lib/BarnOwl/Message/Jabber.pm	(revision 82785437649f6d955c06ed7f26124b223cf70d7d)
@@ -20,5 +20,4 @@
 sub to { shift->{to} };
 sub room { shift->{room} };
-sub nick { shift->{nick} };
 sub subject { shift->{subject} };
 sub status { shift->{status} }
@@ -42,11 +41,4 @@
 sub long_sender {
     my $self = shift;
-    if ($self->jtype eq 'groupchat' && $self->nick) {
-        my $from_jid = Net::Jabber::JID->new($self->from);
-        if ($from_jid->GetJID('base') eq $self->room &&
-            $from_jid->GetResource() eq $self->nick) {
-            return $self->nick;
-        }
-    }
     return $self->from;
 }
Index: perl/modules/Jabber/lib/BarnOwl/Module/Jabber.pm
===================================================================
--- perl/modules/Jabber/lib/BarnOwl/Module/Jabber.pm	(revision 2f25537acb67e620a5be5052f5c2f9a1e5fe3abd)
+++ perl/modules/Jabber/lib/BarnOwl/Module/Jabber.pm	(revision aa0a0b55489e41bbf85f4613156df3e987972b94)
@@ -1241,5 +1241,5 @@
             $muc = $connection->FindMUC(jid => $to);
         }
-        $props{from} = $muc->GetFullJID($from) || $props{from};
+        $props{from} = $muc->GetFullJID($from) || $nick || $room;
         $props{sender} = $nick || $room;
         $props{recipient} = $room;
Index: perl/modules/Twitter/.gitignore
===================================================================
--- perl/modules/Twitter/.gitignore	(revision d27ecf382c5abebd36ad749a62b820ab427c04da)
+++ perl/modules/Twitter/.gitignore	(revision None)
@@ -1,7 +1,7 @@
 *~
 blib/
+inc/
 META.yml
 Makefile
 Twitter.par
 pm_to_blib
-inc/.author
Index: rl/modules/Twitter/inc/Module/Install.pm
===================================================================
--- perl/modules/Twitter/inc/Module/Install.pm	(revision d27ecf382c5abebd36ad749a62b820ab427c04da)
+++ 	(revision )
@@ -1,430 +1,0 @@
-#line 1
-package Module::Install;
-
-# For any maintainers:
-# The load order for Module::Install is a bit magic.
-# It goes something like this...
-#
-# IF ( host has Module::Install installed, creating author mode ) {
-#     1. Makefile.PL calls "use inc::Module::Install"
-#     2. $INC{inc/Module/Install.pm} set to installed version of inc::Module::Install
-#     3. The installed version of inc::Module::Install loads
-#     4. inc::Module::Install calls "require Module::Install"
-#     5. The ./inc/ version of Module::Install loads
-# } ELSE {
-#     1. Makefile.PL calls "use inc::Module::Install"
-#     2. $INC{inc/Module/Install.pm} set to ./inc/ version of Module::Install
-#     3. The ./inc/ version of Module::Install loads
-# }
-
-use 5.005;
-use strict 'vars';
-
-use vars qw{$VERSION $MAIN};
-BEGIN {
-	# All Module::Install core packages now require synchronised versions.
-	# This will be used to ensure we don't accidentally load old or
-	# different versions of modules.
-	# This is not enforced yet, but will be some time in the next few
-	# releases once we can make sure it won't clash with custom
-	# Module::Install extensions.
-	$VERSION = '0.91';
-
-	# Storage for the pseudo-singleton
-	$MAIN    = undef;
-
-	*inc::Module::Install::VERSION = *VERSION;
-	@inc::Module::Install::ISA     = __PACKAGE__;
-
-}
-
-
-
-
-
-# Whether or not inc::Module::Install is actually loaded, the
-# $INC{inc/Module/Install.pm} is what will still get set as long as
-# the caller loaded module this in the documented manner.
-# If not set, the caller may NOT have loaded the bundled version, and thus
-# they may not have a MI version that works with the Makefile.PL. This would
-# result in false errors or unexpected behaviour. And we don't want that.
-my $file = join( '/', 'inc', split /::/, __PACKAGE__ ) . '.pm';
-unless ( $INC{$file} ) { die <<"END_DIE" }
-
-Please invoke ${\__PACKAGE__} with:
-
-	use inc::${\__PACKAGE__};
-
-not:
-
-	use ${\__PACKAGE__};
-
-END_DIE
-
-
-
-
-
-# If the script that is loading Module::Install is from the future,
-# then make will detect this and cause it to re-run over and over
-# again. This is bad. Rather than taking action to touch it (which
-# is unreliable on some platforms and requires write permissions)
-# for now we should catch this and refuse to run.
-if ( -f $0 ) {
-	my $s = (stat($0))[9];
-
-	# If the modification time is only slightly in the future,
-	# sleep briefly to remove the problem.
-	my $a = $s - time;
-	if ( $a > 0 and $a < 5 ) { sleep 5 }
-
-	# Too far in the future, throw an error.
-	my $t = time;
-	if ( $s > $t ) { die <<"END_DIE" }
-
-Your installer $0 has a modification time in the future ($s > $t).
-
-This is known to create infinite loops in make.
-
-Please correct this, then run $0 again.
-
-END_DIE
-}
-
-
-
-
-
-# Build.PL was formerly supported, but no longer is due to excessive
-# difficulty in implementing every single feature twice.
-if ( $0 =~ /Build.PL$/i ) { die <<"END_DIE" }
-
-Module::Install no longer supports Build.PL.
-
-It was impossible to maintain duel backends, and has been deprecated.
-
-Please remove all Build.PL files and only use the Makefile.PL installer.
-
-END_DIE
-
-
-
-
-
-# To save some more typing in Module::Install installers, every...
-# use inc::Module::Install
-# ...also acts as an implicit use strict.
-$^H |= strict::bits(qw(refs subs vars));
-
-
-
-
-
-use Cwd        ();
-use File::Find ();
-use File::Path ();
-use FindBin;
-
-sub autoload {
-	my $self = shift;
-	my $who  = $self->_caller;
-	my $cwd  = Cwd::cwd();
-	my $sym  = "${who}::AUTOLOAD";
-	$sym->{$cwd} = sub {
-		my $pwd = Cwd::cwd();
-		if ( my $code = $sym->{$pwd} ) {
-			# Delegate back to parent dirs
-			goto &$code unless $cwd eq $pwd;
-		}
-		$$sym =~ /([^:]+)$/ or die "Cannot autoload $who - $sym";
-		my $method = $1;
-		if ( uc($method) eq $method ) {
-			# Do nothing
-			return;
-		} elsif ( $method =~ /^_/ and $self->can($method) ) {
-			# Dispatch to the root M:I class
-			return $self->$method(@_);
-		}
-
-		# Dispatch to the appropriate plugin
-		unshift @_, ( $self, $1 );
-		goto &{$self->can('call')};
-	};
-}
-
-sub import {
-	my $class = shift;
-	my $self  = $class->new(@_);
-	my $who   = $self->_caller;
-
-	unless ( -f $self->{file} ) {
-		require "$self->{path}/$self->{dispatch}.pm";
-		File::Path::mkpath("$self->{prefix}/$self->{author}");
-		$self->{admin} = "$self->{name}::$self->{dispatch}"->new( _top => $self );
-		$self->{admin}->init;
-		@_ = ($class, _self => $self);
-		goto &{"$self->{name}::import"};
-	}
-
-	*{"${who}::AUTOLOAD"} = $self->autoload;
-	$self->preload;
-
-	# Unregister loader and worker packages so subdirs can use them again
-	delete $INC{"$self->{file}"};
-	delete $INC{"$self->{path}.pm"};
-
-	# Save to the singleton
-	$MAIN = $self;
-
-	return 1;
-}
-
-sub preload {
-	my $self = shift;
-	unless ( $self->{extensions} ) {
-		$self->load_extensions(
-			"$self->{prefix}/$self->{path}", $self
-		);
-	}
-
-	my @exts = @{$self->{extensions}};
-	unless ( @exts ) {
-		@exts = $self->{admin}->load_all_extensions;
-	}
-
-	my %seen;
-	foreach my $obj ( @exts ) {
-		while (my ($method, $glob) = each %{ref($obj) . '::'}) {
-			next unless $obj->can($method);
-			next if $method =~ /^_/;
-			next if $method eq uc($method);
-			$seen{$method}++;
-		}
-	}
-
-	my $who = $self->_caller;
-	foreach my $name ( sort keys %seen ) {
-		*{"${who}::$name"} = sub {
-			${"${who}::AUTOLOAD"} = "${who}::$name";
-			goto &{"${who}::AUTOLOAD"};
-		};
-	}
-}
-
-sub new {
-	my ($class, %args) = @_;
-
-	# ignore the prefix on extension modules built from top level.
-	my $base_path = Cwd::abs_path($FindBin::Bin);
-	unless ( Cwd::abs_path(Cwd::cwd()) eq $base_path ) {
-		delete $args{prefix};
-	}
-
-	return $args{_self} if $args{_self};
-
-	$args{dispatch} ||= 'Admin';
-	$args{prefix}   ||= 'inc';
-	$args{author}   ||= ($^O eq 'VMS' ? '_author' : '.author');
-	$args{bundle}   ||= 'inc/BUNDLES';
-	$args{base}     ||= $base_path;
-	$class =~ s/^\Q$args{prefix}\E:://;
-	$args{name}     ||= $class;
-	$args{version}  ||= $class->VERSION;
-	unless ( $args{path} ) {
-		$args{path}  = $args{name};
-		$args{path}  =~ s!::!/!g;
-	}
-	$args{file}     ||= "$args{base}/$args{prefix}/$args{path}.pm";
-	$args{wrote}      = 0;
-
-	bless( \%args, $class );
-}
-
-sub call {
-	my ($self, $method) = @_;
-	my $obj = $self->load($method) or return;
-        splice(@_, 0, 2, $obj);
-	goto &{$obj->can($method)};
-}
-
-sub load {
-	my ($self, $method) = @_;
-
-	$self->load_extensions(
-		"$self->{prefix}/$self->{path}", $self
-	) unless $self->{extensions};
-
-	foreach my $obj (@{$self->{extensions}}) {
-		return $obj if $obj->can($method);
-	}
-
-	my $admin = $self->{admin} or die <<"END_DIE";
-The '$method' method does not exist in the '$self->{prefix}' path!
-Please remove the '$self->{prefix}' directory and run $0 again to load it.
-END_DIE
-
-	my $obj = $admin->load($method, 1);
-	push @{$self->{extensions}}, $obj;
-
-	$obj;
-}
-
-sub load_extensions {
-	my ($self, $path, $top) = @_;
-
-	unless ( grep { ! ref $_ and lc $_ eq lc $self->{prefix} } @INC ) {
-		unshift @INC, $self->{prefix};
-	}
-
-	foreach my $rv ( $self->find_extensions($path) ) {
-		my ($file, $pkg) = @{$rv};
-		next if $self->{pathnames}{$pkg};
-
-		local $@;
-		my $new = eval { require $file; $pkg->can('new') };
-		unless ( $new ) {
-			warn $@ if $@;
-			next;
-		}
-		$self->{pathnames}{$pkg} = delete $INC{$file};
-		push @{$self->{extensions}}, &{$new}($pkg, _top => $top );
-	}
-
-	$self->{extensions} ||= [];
-}
-
-sub find_extensions {
-	my ($self, $path) = @_;
-
-	my @found;
-	File::Find::find( sub {
-		my $file = $File::Find::name;
-		return unless $file =~ m!^\Q$path\E/(.+)\.pm\Z!is;
-		my $subpath = $1;
-		return if lc($subpath) eq lc($self->{dispatch});
-
-		$file = "$self->{path}/$subpath.pm";
-		my $pkg = "$self->{name}::$subpath";
-		$pkg =~ s!/!::!g;
-
-		# If we have a mixed-case package name, assume case has been preserved
-		# correctly.  Otherwise, root through the file to locate the case-preserved
-		# version of the package name.
-		if ( $subpath eq lc($subpath) || $subpath eq uc($subpath) ) {
-			my $content = Module::Install::_read($subpath . '.pm');
-			my $in_pod  = 0;
-			foreach ( split //, $content ) {
-				$in_pod = 1 if /^=\w/;
-				$in_pod = 0 if /^=cut/;
-				next if ($in_pod || /^=cut/);  # skip pod text
-				next if /^\s*#/;               # and comments
-				if ( m/^\s*package\s+($pkg)\s*;/i ) {
-					$pkg = $1;
-					last;
-				}
-			}
-		}
-
-		push @found, [ $file, $pkg ];
-	}, $path ) if -d $path;
-
-	@found;
-}
-
-
-
-
-
-#####################################################################
-# Common Utility Functions
-
-sub _caller {
-	my $depth = 0;
-	my $call  = caller($depth);
-	while ( $call eq __PACKAGE__ ) {
-		$depth++;
-		$call = caller($depth);
-	}
-	return $call;
-}
-
-sub _read {
-	local *FH;
-	if ( $] >= 5.006 ) {
-		open( FH, '<', $_[0] ) or die "open($_[0]): $!";
-	} else {
-		open( FH, "< $_[0]"  ) or die "open($_[0]): $!";
-	}
-	my $string = do { local $/; <FH> };
-	close FH or die "close($_[0]): $!";
-	return $string;
-}
-
-sub _readperl {
-	my $string = Module::Install::_read($_[0]);
-	$string =~ s/(?:\015{1,2}\012|\015|\012)/\n/sg;
-	$string =~ s/(\n)\n*__(?:DATA|END)__\b.*\z/$1/s;
-	$string =~ s/\n\n=\w+.+?\n\n=cut\b.+?\n+/\n\n/sg;
-	return $string;
-}
-
-sub _readpod {
-	my $string = Module::Install::_read($_[0]);
-	$string =~ s/(?:\015{1,2}\012|\015|\012)/\n/sg;
-	return $string if $_[0] =~ /\.pod\z/;
-	$string =~ s/(^|\n=cut\b.+?\n+)[^=\s].+?\n(\n=\w+|\z)/$1$2/sg;
-	$string =~ s/\n*=pod\b[^\n]*\n+/\n\n/sg;
-	$string =~ s/\n*=cut\b[^\n]*\n+/\n\n/sg;
-	$string =~ s/^\n+//s;
-	return $string;
-}
-
-sub _write {
-	local *FH;
-	if ( $] >= 5.006 ) {
-		open( FH, '>', $_[0] ) or die "open($_[0]): $!";
-	} else {
-		open( FH, "> $_[0]"  ) or die "open($_[0]): $!";
-	}
-	foreach ( 1 .. $#_ ) {
-		print FH $_[$_] or die "print($_[0]): $!";
-	}
-	close FH or die "close($_[0]): $!";
-}
-
-# _version is for processing module versions (eg, 1.03_05) not
-# Perl versions (eg, 5.8.1).
-sub _version ($) {
-	my $s = shift || 0;
-	my $d =()= $s =~ /(\.)/g;
-	if ( $d >= 2 ) {
-		# Normalise multipart versions
-		$s =~ s/(\.)(\d{1,3})/sprintf("$1%03d",$2)/eg;
-	}
-	$s =~ s/^(\d+)\.?//;
-	my $l = $1 || 0;
-	my @v = map {
-		$_ . '0' x (3 - length $_)
-	} $s =~ /(\d{1,3})\D?/g;
-	$l = $l . '.' . join '', @v if @v;
-	return $l + 0;
-}
-
-sub _cmp ($$) {
-	_version($_[0]) <=> _version($_[1]);
-}
-
-# Cloned from Params::Util::_CLASS
-sub _CLASS ($) {
-	(
-		defined $_[0]
-		and
-		! ref $_[0]
-		and
-		$_[0] =~ m/^[^\W\d]\w*(?:::\w+)*\z/s
-	) ? $_[0] : undef;
-}
-
-1;
-
-# Copyright 2008 - 2009 Adam Kennedy.
Index: rl/modules/Twitter/inc/Module/Install/BarnOwl.pm
===================================================================
--- perl/modules/Twitter/inc/Module/Install/BarnOwl.pm	(revision d27ecf382c5abebd36ad749a62b820ab427c04da)
+++ 	(revision )
@@ -1,31 +1,0 @@
-#line 1
-use warnings;
-use strict;
-
-#line 32
-
-package Module::Install::BarnOwl;
-
-use base qw(Module::Install::Base);
-
-sub barnowl_module {
-    my $self = shift;
-    my $name = ucfirst shift;
-    my $class = ref $self;
-
-    $self->name("BarnOwl-Module-$name");
-    $self->all_from("lib/BarnOwl/Module/$name.pm");
-
-    $self->postamble(<<"END_MAKEFILE");
-
-# --- $class section:
-
-$name.par: pm_to_blib
-\tcd blib; zip -q ../$name.par -r arch lib
-
-END_MAKEFILE
-}
-
-#line 60
-
-1;
Index: rl/modules/Twitter/inc/Module/Install/Base.pm
===================================================================
--- perl/modules/Twitter/inc/Module/Install/Base.pm	(revision d27ecf382c5abebd36ad749a62b820ab427c04da)
+++ 	(revision )
@@ -1,78 +1,0 @@
-#line 1
-package Module::Install::Base;
-
-use strict 'vars';
-use vars qw{$VERSION};
-BEGIN {
-	$VERSION = '0.91';
-}
-
-# Suspend handler for "redefined" warnings
-BEGIN {
-	my $w = $SIG{__WARN__};
-	$SIG{__WARN__} = sub { $w };
-}
-
-#line 42
-
-sub new {
-	my $class = shift;
-	unless ( defined &{"${class}::call"} ) {
-		*{"${class}::call"} = sub { shift->_top->call(@_) };
-	}
-	unless ( defined &{"${class}::load"} ) {
-		*{"${class}::load"} = sub { shift->_top->load(@_) };
-	}
-	bless { @_ }, $class;
-}
-
-#line 61
-
-sub AUTOLOAD {
-	local $@;
-	my $func = eval { shift->_top->autoload } or return;
-	goto &$func;
-}
-
-#line 75
-
-sub _top {
-	$_[0]->{_top};
-}
-
-#line 90
-
-sub admin {
-	$_[0]->_top->{admin}
-	or
-	Module::Install::Base::FakeAdmin->new;
-}
-
-#line 106
-
-sub is_admin {
-	$_[0]->admin->VERSION;
-}
-
-sub DESTROY {}
-
-package Module::Install::Base::FakeAdmin;
-
-my $fake;
-
-sub new {
-	$fake ||= bless(\@_, $_[0]);
-}
-
-sub AUTOLOAD {}
-
-sub DESTROY {}
-
-# Restore warning handler
-BEGIN {
-	$SIG{__WARN__} = $SIG{__WARN__}->();
-}
-
-1;
-
-#line 154
Index: rl/modules/Twitter/inc/Module/Install/Can.pm
===================================================================
--- perl/modules/Twitter/inc/Module/Install/Can.pm	(revision d27ecf382c5abebd36ad749a62b820ab427c04da)
+++ 	(revision )
@@ -1,81 +1,0 @@
-#line 1
-package Module::Install::Can;
-
-use strict;
-use Config                ();
-use File::Spec            ();
-use ExtUtils::MakeMaker   ();
-use Module::Install::Base ();
-
-use vars qw{$VERSION @ISA $ISCORE};
-BEGIN {
-	$VERSION = '0.91';
-	@ISA     = 'Module::Install::Base';
-	$ISCORE  = 1;
-}
-
-# check if we can load some module
-### Upgrade this to not have to load the module if possible
-sub can_use {
-	my ($self, $mod, $ver) = @_;
-	$mod =~ s{::|\\}{/}g;
-	$mod .= '.pm' unless $mod =~ /\.pm$/i;
-
-	my $pkg = $mod;
-	$pkg =~ s{/}{::}g;
-	$pkg =~ s{\.pm$}{}i;
-
-	local $@;
-	eval { require $mod; $pkg->VERSION($ver || 0); 1 };
-}
-
-# check if we can run some command
-sub can_run {
-	my ($self, $cmd) = @_;
-
-	my $_cmd = $cmd;
-	return $_cmd if (-x $_cmd or $_cmd = MM->maybe_command($_cmd));
-
-	for my $dir ((split /$Config::Config{path_sep}/, $ENV{PATH}), '.') {
-		next if $dir eq '';
-		my $abs = File::Spec->catfile($dir, $_[1]);
-		return $abs if (-x $abs or $abs = MM->maybe_command($abs));
-	}
-
-	return;
-}
-
-# can we locate a (the) C compiler
-sub can_cc {
-	my $self   = shift;
-	my @chunks = split(/ /, $Config::Config{cc}) or return;
-
-	# $Config{cc} may contain args; try to find out the program part
-	while (@chunks) {
-		return $self->can_run("@chunks") || (pop(@chunks), next);
-	}
-
-	return;
-}
-
-# Fix Cygwin bug on maybe_command();
-if ( $^O eq 'cygwin' ) {
-	require ExtUtils::MM_Cygwin;
-	require ExtUtils::MM_Win32;
-	if ( ! defined(&ExtUtils::MM_Cygwin::maybe_command) ) {
-		*ExtUtils::MM_Cygwin::maybe_command = sub {
-			my ($self, $file) = @_;
-			if ($file =~ m{^/cygdrive/}i and ExtUtils::MM_Win32->can('maybe_command')) {
-				ExtUtils::MM_Win32->maybe_command($file);
-			} else {
-				ExtUtils::MM_Unix->maybe_command($file);
-			}
-		}
-	}
-}
-
-1;
-
-__END__
-
-#line 156
Index: rl/modules/Twitter/inc/Module/Install/Fetch.pm
===================================================================
--- perl/modules/Twitter/inc/Module/Install/Fetch.pm	(revision d27ecf382c5abebd36ad749a62b820ab427c04da)
+++ 	(revision )
@@ -1,93 +1,0 @@
-#line 1
-package Module::Install::Fetch;
-
-use strict;
-use Module::Install::Base ();
-
-use vars qw{$VERSION @ISA $ISCORE};
-BEGIN {
-	$VERSION = '0.91';
-	@ISA     = 'Module::Install::Base';
-	$ISCORE  = 1;
-}
-
-sub get_file {
-    my ($self, %args) = @_;
-    my ($scheme, $host, $path, $file) =
-        $args{url} =~ m|^(\w+)://([^/]+)(.+)/(.+)| or return;
-
-    if ( $scheme eq 'http' and ! eval { require LWP::Simple; 1 } ) {
-        $args{url} = $args{ftp_url}
-            or (warn("LWP support unavailable!\n"), return);
-        ($scheme, $host, $path, $file) =
-            $args{url} =~ m|^(\w+)://([^/]+)(.+)/(.+)| or return;
-    }
-
-    $|++;
-    print "Fetching '$file' from $host... ";
-
-    unless (eval { require Socket; Socket::inet_aton($host) }) {
-        warn "'$host' resolve failed!\n";
-        return;
-    }
-
-    return unless $scheme eq 'ftp' or $scheme eq 'http';
-
-    require Cwd;
-    my $dir = Cwd::getcwd();
-    chdir $args{local_dir} or return if exists $args{local_dir};
-
-    if (eval { require LWP::Simple; 1 }) {
-        LWP::Simple::mirror($args{url}, $file);
-    }
-    elsif (eval { require Net::FTP; 1 }) { eval {
-        # use Net::FTP to get past firewall
-        my $ftp = Net::FTP->new($host, Passive => 1, Timeout => 600);
-        $ftp->login("anonymous", 'anonymous@example.com');
-        $ftp->cwd($path);
-        $ftp->binary;
-        $ftp->get($file) or (warn("$!\n"), return);
-        $ftp->quit;
-    } }
-    elsif (my $ftp = $self->can_run('ftp')) { eval {
-        # no Net::FTP, fallback to ftp.exe
-        require FileHandle;
-        my $fh = FileHandle->new;
-
-        local $SIG{CHLD} = 'IGNORE';
-        unless ($fh->open("|$ftp -n")) {
-            warn "Couldn't open ftp: $!\n";
-            chdir $dir; return;
-        }
-
-        my @dialog = split(/\n/, <<"END_FTP");
-open $host
-user anonymous anonymous\@example.com
-cd $path
-binary
-get $file $file
-quit
-END_FTP
-        foreach (@dialog) { $fh->print("$_\n") }
-        $fh->close;
-    } }
-    else {
-        warn "No working 'ftp' program available!\n";
-        chdir $dir; return;
-    }
-
-    unless (-f $file) {
-        warn "Fetching failed: $@\n";
-        chdir $dir; return;
-    }
-
-    return if exists $args{size} and -s $file != $args{size};
-    system($args{run}) if exists $args{run};
-    unlink($file) if $args{remove};
-
-    print(((!exists $args{check_for} or -e $args{check_for})
-        ? "done!" : "failed! ($!)"), "\n");
-    chdir $dir; return !$?;
-}
-
-1;
Index: rl/modules/Twitter/inc/Module/Install/Makefile.pm
===================================================================
--- perl/modules/Twitter/inc/Module/Install/Makefile.pm	(revision d27ecf382c5abebd36ad749a62b820ab427c04da)
+++ 	(revision )
@@ -1,268 +1,0 @@
-#line 1
-package Module::Install::Makefile;
-
-use strict 'vars';
-use ExtUtils::MakeMaker   ();
-use Module::Install::Base ();
-
-use vars qw{$VERSION @ISA $ISCORE};
-BEGIN {
-	$VERSION = '0.91';
-	@ISA     = 'Module::Install::Base';
-	$ISCORE  = 1;
-}
-
-sub Makefile { $_[0] }
-
-my %seen = ();
-
-sub prompt {
-	shift;
-
-	# Infinite loop protection
-	my @c = caller();
-	if ( ++$seen{"$c[1]|$c[2]|$_[0]"} > 3 ) {
-		die "Caught an potential prompt infinite loop ($c[1]|$c[2]|$_[0])";
-	}
-
-	# In automated testing, always use defaults
-	if ( $ENV{AUTOMATED_TESTING} and ! $ENV{PERL_MM_USE_DEFAULT} ) {
-		local $ENV{PERL_MM_USE_DEFAULT} = 1;
-		goto &ExtUtils::MakeMaker::prompt;
-	} else {
-		goto &ExtUtils::MakeMaker::prompt;
-	}
-}
-
-sub makemaker_args {
-	my $self = shift;
-	my $args = ( $self->{makemaker_args} ||= {} );
-	%$args = ( %$args, @_ );
-	return $args;
-}
-
-# For mm args that take multiple space-seperated args,
-# append an argument to the current list.
-sub makemaker_append {
-	my $self = sShift;
-	my $name = shift;
-	my $args = $self->makemaker_args;
-	$args->{name} = defined $args->{$name}
-		? join( ' ', $args->{name}, @_ )
-		: join( ' ', @_ );
-}
-
-sub build_subdirs {
-	my $self    = shift;
-	my $subdirs = $self->makemaker_args->{DIR} ||= [];
-	for my $subdir (@_) {
-		push @$subdirs, $subdir;
-	}
-}
-
-sub clean_files {
-	my $self  = shift;
-	my $clean = $self->makemaker_args->{clean} ||= {};
-	  %$clean = (
-		%$clean,
-		FILES => join ' ', grep { length $_ } ($clean->{FILES} || (), @_),
-	);
-}
-
-sub realclean_files {
-	my $self      = shift;
-	my $realclean = $self->makemaker_args->{realclean} ||= {};
-	  %$realclean = (
-		%$realclean,
-		FILES => join ' ', grep { length $_ } ($realclean->{FILES} || (), @_),
-	);
-}
-
-sub libs {
-	my $self = shift;
-	my $libs = ref $_[0] ? shift : [ shift ];
-	$self->makemaker_args( LIBS => $libs );
-}
-
-sub inc {
-	my $self = shift;
-	$self->makemaker_args( INC => shift );
-}
-
-my %test_dir = ();
-
-sub _wanted_t {
-	/\.t$/ and -f $_ and $test_dir{$File::Find::dir} = 1;
-}
-
-sub tests_recursive {
-	my $self = shift;
-	if ( $self->tests ) {
-		die "tests_recursive will not work if tests are already defined";
-	}
-	my $dir = shift || 't';
-	unless ( -d $dir ) {
-		die "tests_recursive dir '$dir' does not exist";
-	}
-	%test_dir = ();
-	require File::Find;
-	File::Find::find( \&_wanted_t, $dir );
-	$self->tests( join ' ', map { "$_/*.t" } sort keys %test_dir );
-}
-
-sub write {
-	my $self = shift;
-	die "&Makefile->write() takes no arguments\n" if @_;
-
-	# Check the current Perl version
-	my $perl_version = $self->perl_version;
-	if ( $perl_version ) {
-		eval "use $perl_version; 1"
-			or die "ERROR: perl: Version $] is installed, "
-			. "but we need version >= $perl_version";
-	}
-
-	# Make sure we have a new enough MakeMaker
-	require ExtUtils::MakeMaker;
-
-	if ( $perl_version and $self->_cmp($perl_version, '5.006') >= 0 ) {
-		# MakeMaker can complain about module versions that include
-		# an underscore, even though its own version may contain one!
-		# Hence the funny regexp to get rid of it.  See RT #35800
-		# for details.
-		$self->build_requires( 'ExtUtils::MakeMaker' => $ExtUtils::MakeMaker::VERSION =~ /^(\d+\.\d+)/ );
-		$self->configure_requires( 'ExtUtils::MakeMaker' => $ExtUtils::MakeMaker::VERSION =~ /^(\d+\.\d+)/ );
-	} else {
-		# Allow legacy-compatibility with 5.005 by depending on the
-		# most recent EU:MM that supported 5.005.
-		$self->build_requires( 'ExtUtils::MakeMaker' => 6.42 );
-		$self->configure_requires( 'ExtUtils::MakeMaker' => 6.42 );
-	}
-
-	# Generate the MakeMaker params
-	my $args = $self->makemaker_args;
-	$args->{DISTNAME} = $self->name;
-	$args->{NAME}     = $self->module_name || $self->name;
-	$args->{VERSION}  = $self->version;
-	$args->{NAME}     =~ s/-/::/g;
-	if ( $self->tests ) {
-		$args->{test} = { TESTS => $self->tests };
-	}
-	if ( $] >= 5.005 ) {
-		$args->{ABSTRACT} = $self->abstract;
-		$args->{AUTHOR}   = $self->author;
-	}
-	if ( eval($ExtUtils::MakeMaker::VERSION) >= 6.10 ) {
-		$args->{NO_META} = 1;
-	}
-	if ( eval($ExtUtils::MakeMaker::VERSION) > 6.17 and $self->sign ) {
-		$args->{SIGN} = 1;
-	}
-	unless ( $self->is_admin ) {
-		delete $args->{SIGN};
-	}
-
-	# Merge both kinds of requires into prereq_pm
-	my $prereq = ($args->{PREREQ_PM} ||= {});
-	%$prereq = ( %$prereq,
-		map { @$_ }
-		map { @$_ }
-		grep $_,
-		($self->configure_requires, $self->build_requires, $self->requires)
-	);
-
-	# Remove any reference to perl, PREREQ_PM doesn't support it
-	delete $args->{PREREQ_PM}->{perl};
-
-	# merge both kinds of requires into prereq_pm
-	my $subdirs = ($args->{DIR} ||= []);
-	if ($self->bundles) {
-		foreach my $bundle (@{ $self->bundles }) {
-			my ($file, $dir) = @$bundle;
-			push @$subdirs, $dir if -d $dir;
-			delete $prereq->{$file};
-		}
-	}
-
-	if ( my $perl_version = $self->perl_version ) {
-		eval "use $perl_version; 1"
-			or die "ERROR: perl: Version $] is installed, "
-			. "but we need version >= $perl_version";
-	}
-
-	$args->{INSTALLDIRS} = $self->installdirs;
-
-	my %args = map { ( $_ => $args->{$_} ) } grep {defined($args->{$_})} keys %$args;
-
-	my $user_preop = delete $args{dist}->{PREOP};
-	if (my $preop = $self->admin->preop($user_preop)) {
-		foreach my $key ( keys %$preop ) {
-			$args{dist}->{$key} = $preop->{$key};
-		}
-	}
-
-	my $mm = ExtUtils::MakeMaker::WriteMakefile(%args);
-	$self->fix_up_makefile($mm->{FIRST_MAKEFILE} || 'Makefile');
-}
-
-sub fix_up_makefile {
-	my $self          = shift;
-	my $makefile_name = shift;
-	my $top_class     = ref($self->_top) || '';
-	my $top_version   = $self->_top->VERSION || '';
-
-	my $preamble = $self->preamble
-		? "# Preamble by $top_class $top_version\n"
-			. $self->preamble
-		: '';
-	my $postamble = "# Postamble by $top_class $top_version\n"
-		. ($self->postamble || '');
-
-	local *MAKEFILE;
-	open MAKEFILE, "< $makefile_name" or die "fix_up_makefile: Couldn't open $makefile_name: $!";
-	my $makefile = do { local $/; <MAKEFILE> };
-	close MAKEFILE or die $!;
-
-	$makefile =~ s/\b(test_harness\(\$\(TEST_VERBOSE\), )/$1'inc', /;
-	$makefile =~ s/( -I\$\(INST_ARCHLIB\))/ -Iinc$1/g;
-	$makefile =~ s/( "-I\$\(INST_LIB\)")/ "-Iinc"$1/g;
-	$makefile =~ s/^(FULLPERL = .*)/$1 "-Iinc"/m;
-	$makefile =~ s/^(PERL = .*)/$1 "-Iinc"/m;
-
-	# Module::Install will never be used to build the Core Perl
-	# Sometimes PERL_LIB and PERL_ARCHLIB get written anyway, which breaks
-	# PREFIX/PERL5LIB, and thus, install_share. Blank them if they exist
-	$makefile =~ s/^PERL_LIB = .+/PERL_LIB =/m;
-	#$makefile =~ s/^PERL_ARCHLIB = .+/PERL_ARCHLIB =/m;
-
-	# Perl 5.005 mentions PERL_LIB explicitly, so we have to remove that as well.
-	$makefile =~ s/(\"?)-I\$\(PERL_LIB\)\1//g;
-
-	# XXX - This is currently unused; not sure if it breaks other MM-users
-	# $makefile =~ s/^pm_to_blib\s+:\s+/pm_to_blib :: /mg;
-
-	open  MAKEFILE, "> $makefile_name" or die "fix_up_makefile: Couldn't open $makefile_name: $!";
-	print MAKEFILE  "$preamble$makefile$postamble" or die $!;
-	close MAKEFILE  or die $!;
-
-	1;
-}
-
-sub preamble {
-	my ($self, $text) = @_;
-	$self->{preamble} = $text . $self->{preamble} if defined $text;
-	$self->{preamble};
-}
-
-sub postamble {
-	my ($self, $text) = @_;
-	$self->{postamble} ||= $self->admin->postamble;
-	$self->{postamble} .= $text if defined $text;
-	$self->{postamble}
-}
-
-1;
-
-__END__
-
-#line 394
Index: rl/modules/Twitter/inc/Module/Install/Metadata.pm
===================================================================
--- perl/modules/Twitter/inc/Module/Install/Metadata.pm	(revision d27ecf382c5abebd36ad749a62b820ab427c04da)
+++ 	(revision )
@@ -1,624 +1,0 @@
-#line 1
-package Module::Install::Metadata;
-
-use strict 'vars';
-use Module::Install::Base ();
-
-use vars qw{$VERSION @ISA $ISCORE};
-BEGIN {
-	$VERSION = '0.91';
-	@ISA     = 'Module::Install::Base';
-	$ISCORE  = 1;
-}
-
-my @boolean_keys = qw{
-	sign
-};
-
-my @scalar_keys = qw{
-	name
-	module_name
-	abstract
-	author
-	version
-	distribution_type
-	tests
-	installdirs
-};
-
-my @tuple_keys = qw{
-	configure_requires
-	build_requires
-	requires
-	recommends
-	bundles
-	resources
-};
-
-my @resource_keys = qw{
-	homepage
-	bugtracker
-	repository
-};
-
-my @array_keys = qw{
-	keywords
-};
-
-sub Meta              { shift          }
-sub Meta_BooleanKeys  { @boolean_keys  }
-sub Meta_ScalarKeys   { @scalar_keys   }
-sub Meta_TupleKeys    { @tuple_keys    }
-sub Meta_ResourceKeys { @resource_keys }
-sub Meta_ArrayKeys    { @array_keys    }
-
-foreach my $key ( @boolean_keys ) {
-	*$key = sub {
-		my $self = shift;
-		if ( defined wantarray and not @_ ) {
-			return $self->{values}->{$key};
-		}
-		$self->{values}->{$key} = ( @_ ? $_[0] : 1 );
-		return $self;
-	};
-}
-
-foreach my $key ( @scalar_keys ) {
-	*$key = sub {
-		my $self = shift;
-		return $self->{values}->{$key} if defined wantarray and !@_;
-		$self->{values}->{$key} = shift;
-		return $self;
-	};
-}
-
-foreach my $key ( @array_keys ) {
-	*$key = sub {
-		my $self = shift;
-		return $self->{values}->{$key} if defined wantarray and !@_;
-		$self->{values}->{$key} ||= [];
-		push @{$self->{values}->{$key}}, @_;
-		return $self;
-	};
-}
-
-foreach my $key ( @resource_keys ) {
-	*$key = sub {
-		my $self = shift;
-		unless ( @_ ) {
-			return () unless $self->{values}->{resources};
-			return map  { $_->[1] }
-			       grep { $_->[0] eq $key }
-			       @{ $self->{values}->{resources} };
-		}
-		return $self->{values}->{resources}->{$key} unless @_;
-		my $uri = shift or die(
-			"Did not provide a value to $key()"
-		);
-		$self->resources( $key => $uri );
-		return 1;
-	};
-}
-
-foreach my $key ( grep { $_ ne "resources" } @tuple_keys) {
-	*$key = sub {
-		my $self = shift;
-		return $self->{values}->{$key} unless @_;
-		my @added;
-		while ( @_ ) {
-			my $module  = shift or last;
-			my $version = shift || 0;
-			push @added, [ $module, $version ];
-		}
-		push @{ $self->{values}->{$key} }, @added;
-		return map {@$_} @added;
-	};
-}
-
-# Resource handling
-my %lc_resource = map { $_ => 1 } qw{
-	homepage
-	license
-	bugtracker
-	repository
-};
-
-sub resources {
-	my $self = shift;
-	while ( @_ ) {
-		my $name  = shift or last;
-		my $value = shift or next;
-		if ( $name eq lc $name and ! $lc_resource{$name} ) {
-			die("Unsupported reserved lowercase resource '$name'");
-		}
-		$self->{values}->{resources} ||= [];
-		push @{ $self->{values}->{resources} }, [ $name, $value ];
-	}
-	$self->{values}->{resources};
-}
-
-# Aliases for build_requires that will have alternative
-# meanings in some future version of META.yml.
-sub test_requires     { shift->build_requires(@_) }
-sub install_requires  { shift->build_requires(@_) }
-
-# Aliases for installdirs options
-sub install_as_core   { $_[0]->installdirs('perl')   }
-sub install_as_cpan   { $_[0]->installdirs('site')   }
-sub install_as_site   { $_[0]->installdirs('site')   }
-sub install_as_vendor { $_[0]->installdirs('vendor') }
-
-sub dynamic_config {
-	my $self = shift;
-	unless ( @_ ) {
-		warn "You MUST provide an explicit true/false value to dynamic_config\n";
-		return $self;
-	}
-	$self->{values}->{dynamic_config} = $_[0] ? 1 : 0;
-	return 1;
-}
-
-sub perl_version {
-	my $self = shift;
-	return $self->{values}->{perl_version} unless @_;
-	my $version = shift or die(
-		"Did not provide a value to perl_version()"
-	);
-
-	# Normalize the version
-	$version = $self->_perl_version($version);
-
-	# We don't support the reall old versions
-	unless ( $version >= 5.005 ) {
-		die "Module::Install only supports 5.005 or newer (use ExtUtils::MakeMaker)\n";
-	}
-
-	$self->{values}->{perl_version} = $version;
-}
-
-#Stolen from M::B
-my %license_urls = (
-    perl         => 'http://dev.perl.org/licenses/',
-    apache       => 'http://apache.org/licenses/LICENSE-2.0',
-    artistic     => 'http://opensource.org/licenses/artistic-license.php',
-    artistic_2   => 'http://opensource.org/licenses/artistic-license-2.0.php',
-    lgpl         => 'http://opensource.org/licenses/lgpl-license.php',
-    lgpl2        => 'http://opensource.org/licenses/lgpl-2.1.php',
-    lgpl3        => 'http://opensource.org/licenses/lgpl-3.0.html',
-    bsd          => 'http://opensource.org/licenses/bsd-license.php',
-    gpl          => 'http://opensource.org/licenses/gpl-license.php',
-    gpl2         => 'http://opensource.org/licenses/gpl-2.0.php',
-    gpl3         => 'http://opensource.org/licenses/gpl-3.0.html',
-    mit          => 'http://opensource.org/licenses/mit-license.php',
-    mozilla      => 'http://opensource.org/licenses/mozilla1.1.php',
-    open_source  => undef,
-    unrestricted => undef,
-    restrictive  => undef,
-    unknown      => undef,
-);
-
-sub license {
-	my $self = shift;
-	return $self->{values}->{license} unless @_;
-	my $license = shift or die(
-		'Did not provide a value to license()'
-	);
-	$self->{values}->{license} = $license;
-
-	# Automatically fill in license URLs
-	if ( $license_urls{$license} ) {
-		$self->resources( license => $license_urls{$license} );
-	}
-
-	return 1;
-}
-
-sub all_from {
-	my ( $self, $file ) = @_;
-
-	unless ( defined($file) ) {
-		my $name = $self->name or die(
-			"all_from called with no args without setting name() first"
-		);
-		$file = join('/', 'lib', split(/-/, $name)) . '.pm';
-		$file =~ s{.*/}{} unless -e $file;
-		unless ( -e $file ) {
-			die("all_from cannot find $file from $name");
-		}
-	}
-	unless ( -f $file ) {
-		die("The path '$file' does not exist, or is not a file");
-	}
-
-	# Some methods pull from POD instead of code.
-	# If there is a matching .pod, use that instead
-	my $pod = $file;
-	$pod =~ s/\.pm$/.pod/i;
-	$pod = $file unless -e $pod;
-
-	# Pull the different values
-	$self->name_from($file)         unless $self->name;
-	$self->version_from($file)      unless $self->version;
-	$self->perl_version_from($file) unless $self->perl_version;
-	$self->author_from($pod)        unless $self->author;
-	$self->license_from($pod)       unless $self->license;
-	$self->abstract_from($pod)      unless $self->abstract;
-
-	return 1;
-}
-
-sub provides {
-	my $self     = shift;
-	my $provides = ( $self->{values}->{provides} ||= {} );
-	%$provides = (%$provides, @_) if @_;
-	return $provides;
-}
-
-sub auto_provides {
-	my $self = shift;
-	return $self unless $self->is_admin;
-	unless (-e 'MANIFEST') {
-		warn "Cannot deduce auto_provides without a MANIFEST, skipping\n";
-		return $self;
-	}
-	# Avoid spurious warnings as we are not checking manifest here.
-	local $SIG{__WARN__} = sub {1};
-	require ExtUtils::Manifest;
-	local *ExtUtils::Manifest::manicheck = sub { return };
-
-	require Module::Build;
-	my $build = Module::Build->new(
-		dist_name    => $self->name,
-		dist_version => $self->version,
-		license      => $self->license,
-	);
-	$self->provides( %{ $build->find_dist_packages || {} } );
-}
-
-sub feature {
-	my $self     = shift;
-	my $name     = shift;
-	my $features = ( $self->{values}->{features} ||= [] );
-	my $mods;
-
-	if ( @_ == 1 and ref( $_[0] ) ) {
-		# The user used ->feature like ->features by passing in the second
-		# argument as a reference.  Accomodate for that.
-		$mods = $_[0];
-	} else {
-		$mods = \@_;
-	}
-
-	my $count = 0;
-	push @$features, (
-		$name => [
-			map {
-				ref($_) ? ( ref($_) eq 'HASH' ) ? %$_ : @$_ : $_
-			} @$mods
-		]
-	);
-
-	return @$features;
-}
-
-sub features {
-	my $self = shift;
-	while ( my ( $name, $mods ) = splice( @_, 0, 2 ) ) {
-		$self->feature( $name, @$mods );
-	}
-	return $self->{values}->{features}
-		? @{ $self->{values}->{features} }
-		: ();
-}
-
-sub no_index {
-	my $self = shift;
-	my $type = shift;
-	push @{ $self->{values}->{no_index}->{$type} }, @_ if $type;
-	return $self->{values}->{no_index};
-}
-
-sub read {
-	my $self = shift;
-	$self->include_deps( 'YAML::Tiny', 0 );
-
-	require YAML::Tiny;
-	my $data = YAML::Tiny::LoadFile('META.yml');
-
-	# Call methods explicitly in case user has already set some values.
-	while ( my ( $key, $value ) = each %$data ) {
-		next unless $self->can($key);
-		if ( ref $value eq 'HASH' ) {
-			while ( my ( $module, $version ) = each %$value ) {
-				$self->can($key)->($self, $module => $version );
-			}
-		} else {
-			$self->can($key)->($self, $value);
-		}
-	}
-	return $self;
-}
-
-sub write {
-	my $self = shift;
-	return $self unless $self->is_admin;
-	$self->admin->write_meta;
-	return $self;
-}
-
-sub version_from {
-	require ExtUtils::MM_Unix;
-	my ( $self, $file ) = @_;
-	$self->version( ExtUtils::MM_Unix->parse_version($file) );
-}
-
-sub abstract_from {
-	require ExtUtils::MM_Unix;
-	my ( $self, $file ) = @_;
-	$self->abstract(
-		bless(
-			{ DISTNAME => $self->name },
-			'ExtUtils::MM_Unix'
-		)->parse_abstract($file)
-	 );
-}
-
-# Add both distribution and module name
-sub name_from {
-	my ($self, $file) = @_;
-	if (
-		Module::Install::_read($file) =~ m/
-		^ \s*
-		package \s*
-		([\w:]+)
-		\s* ;
-		/ixms
-	) {
-		my ($name, $module_name) = ($1, $1);
-		$name =~ s{::}{-}g;
-		$self->name($name);
-		unless ( $self->module_name ) {
-			$self->module_name($module_name);
-		}
-	} else {
-		die("Cannot determine name from $file\n");
-	}
-}
-
-sub perl_version_from {
-	my $self = shift;
-	if (
-		Module::Install::_read($_[0]) =~ m/
-		^
-		(?:use|require) \s*
-		v?
-		([\d_\.]+)
-		\s* ;
-		/ixms
-	) {
-		my $perl_version = $1;
-		$perl_version =~ s{_}{}g;
-		$self->perl_version($perl_version);
-	} else {
-		warn "Cannot determine perl version info from $_[0]\n";
-		return;
-	}
-}
-
-sub author_from {
-	my $self    = shift;
-	my $content = Module::Install::_read($_[0]);
-	if ($content =~ m/
-		=head \d \s+ (?:authors?)\b \s*
-		([^\n]*)
-		|
-		=head \d \s+ (?:licen[cs]e|licensing|copyright|legal)\b \s*
-		.*? copyright .*? \d\d\d[\d.]+ \s* (?:\bby\b)? \s*
-		([^\n]*)
-	/ixms) {
-		my $author = $1 || $2;
-		$author =~ s{E<lt>}{<}g;
-		$author =~ s{E<gt>}{>}g;
-		$self->author($author);
-	} else {
-		warn "Cannot determine author info from $_[0]\n";
-	}
-}
-
-sub license_from {
-	my $self = shift;
-	if (
-		Module::Install::_read($_[0]) =~ m/
-		(
-			=head \d \s+
-			(?:licen[cs]e|licensing|copyright|legal)\b
-			.*?
-		)
-		(=head\\d.*|=cut.*|)
-		\z
-	/ixms ) {
-		my $license_text = $1;
-		my @phrases      = (
-			'under the same (?:terms|license) as (?:perl|the perl programming language) itself' => 'perl', 1,
-			'GNU general public license'         => 'gpl',         1,
-			'GNU public license'                 => 'gpl',         1,
-			'GNU lesser general public license'  => 'lgpl',        1,
-			'GNU lesser public license'          => 'lgpl',        1,
-			'GNU library general public license' => 'lgpl',        1,
-			'GNU library public license'         => 'lgpl',        1,
-			'BSD license'                        => 'bsd',         1,
-			'Artistic license'                   => 'artistic',    1,
-			'GPL'                                => 'gpl',         1,
-			'LGPL'                               => 'lgpl',        1,
-			'BSD'                                => 'bsd',         1,
-			'Artistic'                           => 'artistic',    1,
-			'MIT'                                => 'mit',         1,
-			'proprietary'                        => 'proprietary', 0,
-		);
-		while ( my ($pattern, $license, $osi) = splice(@phrases, 0, 3) ) {
-			$pattern =~ s{\s+}{\\s+}g;
-			if ( $license_text =~ /\b$pattern\b/i ) {
-				$self->license($license);
-				return 1;
-			}
-		}
-	}
-
-	warn "Cannot determine license info from $_[0]\n";
-	return 'unknown';
-}
-
-sub _extract_bugtracker {
-	my @links   = $_[0] =~ m#L<(\Qhttp://rt.cpan.org/\E[^>]+)>#g;
-	my %links;
-	@links{@links}=();
-	@links=keys %links;
-	return @links;
-}
-
-sub bugtracker_from {
-	my $self    = shift;
-	my $content = Module::Install::_read($_[0]);
-	my @links   = _extract_bugtracker($content);
-	unless ( @links ) {
-		warn "Cannot determine bugtracker info from $_[0]\n";
-		return 0;
-	}
-	if ( @links > 1 ) {
-		warn "Found more than on rt.cpan.org link in $_[0]\n";
-		return 0;
-	}
-
-	# Set the bugtracker
-	bugtracker( $links[0] );
-	return 1;
-}
-
-sub requires_from {
-	my $self     = shift;
-	my $content  = Module::Install::_readperl($_[0]);
-	my @requires = $content =~ m/^use\s+([^\W\d]\w*(?:::\w+)*)\s+([\d\.]+)/mg;
-	while ( @requires ) {
-		my $module  = shift @requires;
-		my $version = shift @requires;
-		$self->requires( $module => $version );
-	}
-}
-
-sub test_requires_from {
-	my $self     = shift;
-	my $content  = Module::Install::_readperl($_[0]);
-	my @requires = $content =~ m/^use\s+([^\W\d]\w*(?:::\w+)*)\s+([\d\.]+)/mg;
-	while ( @requires ) {
-		my $module  = shift @requires;
-		my $version = shift @requires;
-		$self->test_requires( $module => $version );
-	}
-}
-
-# Convert triple-part versions (eg, 5.6.1 or 5.8.9) to
-# numbers (eg, 5.006001 or 5.008009).
-# Also, convert double-part versions (eg, 5.8)
-sub _perl_version {
-	my $v = $_[-1];
-	$v =~ s/^([1-9])\.([1-9]\d?\d?)$/sprintf("%d.%03d",$1,$2)/e;
-	$v =~ s/^([1-9])\.([1-9]\d?\d?)\.(0|[1-9]\d?\d?)$/sprintf("%d.%03d%03d",$1,$2,$3 || 0)/e;
-	$v =~ s/(\.\d\d\d)000$/$1/;
-	$v =~ s/_.+$//;
-	if ( ref($v) ) {
-		# Numify
-		$v = $v + 0;
-	}
-	return $v;
-}
-
-
-
-
-
-######################################################################
-# MYMETA Support
-
-sub WriteMyMeta {
-	die "WriteMyMeta has been deprecated";
-}
-
-sub write_mymeta_yaml {
-	my $self = shift;
-
-	# We need YAML::Tiny to write the MYMETA.yml file
-	unless ( eval { require YAML::Tiny; 1; } ) {
-		return 1;
-	}
-
-	# Generate the data
-	my $meta = $self->_write_mymeta_data or return 1;
-
-	# Save as the MYMETA.yml file
-	print "Writing MYMETA.yml\n";
-	YAML::Tiny::DumpFile('MYMETA.yml', $meta);
-}
-
-sub write_mymeta_json {
-	my $self = shift;
-
-	# We need JSON to write the MYMETA.json file
-	unless ( eval { require JSON; 1; } ) {
-		return 1;
-	}
-
-	# Generate the data
-	my $meta = $self->_write_mymeta_data or return 1;
-
-	# Save as the MYMETA.yml file
-	print "Writing MYMETA.json\n";
-	Module::Install::_write(
-		'MYMETA.json',
-		JSON->new->pretty(1)->canonical->encode($meta),
-	);
-}
-
-sub _write_mymeta_data {
-	my $self = shift;
-
-	# If there's no existing META.yml there is nothing we can do
-	return undef unless -f 'META.yml';
-
-	# We need Parse::CPAN::Meta to load the file
-	unless ( eval { require Parse::CPAN::Meta; 1; } ) {
-		return undef;
-	}
-
-	# Merge the perl version into the dependencies
-	my $val  = $self->Meta->{values};
-	my $perl = delete $val->{perl_version};
-	if ( $perl ) {
-		$val->{requires} ||= [];
-		my $requires = $val->{requires};
-
-		# Canonize to three-dot version after Perl 5.6
-		if ( $perl >= 5.006 ) {
-			$perl =~ s{^(\d+)\.(\d\d\d)(\d*)}{join('.', $1, int($2||0), int($3||0))}e
-		}
-		unshift @$requires, [ perl => $perl ];
-	}
-
-	# Load the advisory META.yml file
-	my @yaml = Parse::CPAN::Meta::LoadFile('META.yml');
-	my $meta = $yaml[0];
-
-	# Overwrite the non-configure dependency hashs
-	delete $meta->{requires};
-	delete $meta->{build_requires};
-	delete $meta->{recommends};
-	if ( exists $val->{requires} ) {
-		$meta->{requires} = { map { @$_ } @{ $val->{requires} } };
-	}
-	if ( exists $val->{build_requires} ) {
-		$meta->{build_requires} = { map { @$_ } @{ $val->{build_requires} } };
-	}
-
-	return $meta;
-}
-
-1;
Index: rl/modules/Twitter/inc/Module/Install/Win32.pm
===================================================================
--- perl/modules/Twitter/inc/Module/Install/Win32.pm	(revision d27ecf382c5abebd36ad749a62b820ab427c04da)
+++ 	(revision )
@@ -1,64 +1,0 @@
-#line 1
-package Module::Install::Win32;
-
-use strict;
-use Module::Install::Base ();
-
-use vars qw{$VERSION @ISA $ISCORE};
-BEGIN {
-	$VERSION = '0.91';
-	@ISA     = 'Module::Install::Base';
-	$ISCORE  = 1;
-}
-
-# determine if the user needs nmake, and download it if needed
-sub check_nmake {
-	my $self = shift;
-	$self->load('can_run');
-	$self->load('get_file');
-
-	require Config;
-	return unless (
-		$^O eq 'MSWin32'                     and
-		$Config::Config{make}                and
-		$Config::Config{make} =~ /^nmake\b/i and
-		! $self->can_run('nmake')
-	);
-
-	print "The required 'nmake' executable not found, fetching it...\n";
-
-	require File::Basename;
-	my $rv = $self->get_file(
-		url       => 'http://download.microsoft.com/download/vc15/Patch/1.52/W95/EN-US/Nmake15.exe',
-		ftp_url   => 'ftp://ftp.microsoft.com/Softlib/MSLFILES/Nmake15.exe',
-		local_dir => File::Basename::dirname($^X),
-		size      => 51928,
-		run       => 'Nmake15.exe /o > nul',
-		check_for => 'Nmake.exe',
-		remove    => 1,
-	);
-
-	die <<'END_MESSAGE' unless $rv;
-
--------------------------------------------------------------------------------
-
-Since you are using Microsoft Windows, you will need the 'nmake' utility
-before installation. It's available at:
-
-  http://download.microsoft.com/download/vc15/Patch/1.52/W95/EN-US/Nmake15.exe
-      or
-  ftp://ftp.microsoft.com/Softlib/MSLFILES/Nmake15.exe
-
-Please download the file manually, save it to a directory in %PATH% (e.g.
-C:\WINDOWS\COMMAND\), then launch the MS-DOS command line shell, "cd" to
-that directory, and run "Nmake15.exe" from there; that will create the
-'nmake.exe' file needed by this module.
-
-You may then resume the installation process described in README.
-
--------------------------------------------------------------------------------
-END_MESSAGE
-
-}
-
-1;
Index: rl/modules/Twitter/inc/Module/Install/WriteAll.pm
===================================================================
--- perl/modules/Twitter/inc/Module/Install/WriteAll.pm	(revision d27ecf382c5abebd36ad749a62b820ab427c04da)
+++ 	(revision )
@@ -1,60 +1,0 @@
-#line 1
-package Module::Install::WriteAll;
-
-use strict;
-use Module::Install::Base ();
-
-use vars qw{$VERSION @ISA $ISCORE};
-BEGIN {
-	$VERSION = '0.91';;
-	@ISA     = qw{Module::Install::Base};
-	$ISCORE  = 1;
-}
-
-sub WriteAll {
-	my $self = shift;
-	my %args = (
-		meta        => 1,
-		sign        => 0,
-		inline      => 0,
-		check_nmake => 1,
-		@_,
-	);
-
-	$self->sign(1)                if $args{sign};
-	$self->admin->WriteAll(%args) if $self->is_admin;
-
-	$self->check_nmake if $args{check_nmake};
-	unless ( $self->makemaker_args->{PL_FILES} ) {
-		$self->makemaker_args( PL_FILES => {} );
-	}
-
-	# Until ExtUtils::MakeMaker support MYMETA.yml, make sure
-	# we clean it up properly ourself.
-	$self->realclean_files('MYMETA.yml');
-
-	if ( $args{inline} ) {
-		$self->Inline->write;
-	} else {
-		$self->Makefile->write;
-	}
-
-	# The Makefile write process adds a couple of dependencies,
-	# so write the META.yml files after the Makefile.
-	if ( $args{meta} ) {
-		$self->Meta->write;
-	}
-
-	# Experimental support for MYMETA
-	if ( $ENV{X_MYMETA} ) {
-		if ( $ENV{X_MYMETA} eq 'JSON' ) {
-			$self->Meta->write_mymeta_json;
-		} else {
-			$self->Meta->write_mymeta_yaml;
-		}
-	}
-
-	return 1;
-}
-
-1;
Index: perl/modules/Twitter/lib/BarnOwl/Message/Twitter.pm
===================================================================
--- perl/modules/Twitter/lib/BarnOwl/Message/Twitter.pm	(revision 5d59c1e2fa97f16e6d4846aafc08a19b4c51b145)
+++ perl/modules/Twitter/lib/BarnOwl/Message/Twitter.pm	(revision f6413c3828158563561f959997e05f0dac0d7432)
@@ -17,14 +17,9 @@
 sub service { return (shift->{"service"} || "http://twitter.com"); }
 sub account { return shift->{"account"}; }
-sub retweeted_by { shift->{retweeted_by}; }
 sub long_sender {
     my $self = shift;
     $self->service =~ m#^\s*(.*?://.*?)/.*$#;
     my $service = $1 || $self->service;
-    my $long = $service . '/' . $self->sender;
-    if ($self->retweeted_by) {
-        $long = "(retweeted by " . $self->retweeted_by . ") $long";
-    }
-    return $long;
+    return $service . '/' . $self->sender
 }
 
Index: perl/modules/Twitter/lib/BarnOwl/Module/Twitter/Handle.pm
===================================================================
--- perl/modules/Twitter/lib/BarnOwl/Module/Twitter/Handle.pm	(revision 5d59c1e2fa97f16e6d4846aafc08a19b4c51b145)
+++ perl/modules/Twitter/lib/BarnOwl/Module/Twitter/Handle.pm	(revision a2640485b433a93c521e9b6d664c8df12b3154ad)
@@ -248,19 +248,15 @@
                 next;
             }
-            my $orig = $tweet->{retweeted_status};
-            $orig = $tweet unless defined($orig);
-
             my $msg = BarnOwl::Message->new(
                 type      => 'Twitter',
-                sender    => $orig->{user}{screen_name},
+                sender    => $tweet->{user}{screen_name},
                 recipient => $self->{cfg}->{user} || $self->{user},
                 direction => 'in',
-                source    => decode_entities($orig->{source}),
-                location  => decode_entities($orig->{user}{location}||""),
-                body      => decode_entities($orig->{text}),
+                source    => decode_entities($tweet->{source}),
+                location  => decode_entities($tweet->{user}{location}||""),
+                body      => decode_entities($tweet->{text}),
                 status_id => $tweet->{id},
                 service   => $self->{cfg}->{service},
                 account   => $self->{cfg}->{account_nickname},
-                $tweet->{retweeted_status} ? (retweeted_by => $tweet->{user}{screen_name}) : ()
                );
             BarnOwl::queue_message($msg);
Index: perl_tester.c
===================================================================
--- perl_tester.c	(revision 737b8f16912a0ac4905cb24609e3980fc2378717)
+++ perl_tester.c	(revision 737b8f16912a0ac4905cb24609e3980fc2378717)
@@ -0,0 +1,36 @@
+#define OWL_PERL
+#include "owl.h"
+
+owl_global g;
+
+extern XS(boot_BarnOwl);
+extern XS(boot_DynaLoader);
+/* extern XS(boot_DBI); */
+
+static void owl_perl_xs_init(pTHX)
+{
+  const char *file = __FILE__;
+  dXSUB_SYS;
+  {
+    newXS("BarnOwl::bootstrap", boot_BarnOwl, file);
+    newXS("DynaLoader::boot_DynaLoader", boot_DynaLoader, file);
+  }
+}
+
+static PerlInterpreter *my_perl;  /***    The Perl interpreter    ***/
+
+int main(int argc, char **argv, char **env)
+{
+  /* Code from perldoc perlembed */
+  PERL_SYS_INIT3(&argc,&argv,&env);
+  my_perl = perl_alloc();
+  perl_construct(my_perl);
+  PL_exit_flags |= PERL_EXIT_DESTRUCT_END;
+  perl_parse(my_perl, owl_perl_xs_init, argc, argv, (char **)NULL);
+  perl_run(my_perl);
+  perl_destruct(my_perl);
+  perl_free(my_perl);
+  PERL_SYS_TERM();
+  return 0;
+}
+
Index: perlconfig.c
===================================================================
--- perlconfig.c	(revision 5aa33fd73dce2c8d6c88559e62cd1ae78ef4a36d)
+++ perlconfig.c	(revision 3aa05226f2c729940957d231891ed429669e255f)
@@ -12,5 +12,5 @@
 /* extern XS(boot_DBI); */
 
-void owl_perl_xs_init(pTHX) /* noproto */
+static void owl_perl_xs_init(pTHX)
 {
   const char *file = __FILE__;
@@ -363,6 +363,4 @@
   perl_construct(p);
 
-  PL_exit_flags |= PERL_EXIT_DESTRUCT_END;
-
   owl_global_set_no_have_config(&g);
 
Index: runtests.sh
===================================================================
--- runtests.sh	(revision 5aa33fd73dce2c8d6c88559e62cd1ae78ef4a36d)
+++ runtests.sh	(revision 9f026c14abe876082d0f781b81a150548e4b0783)
@@ -1,7 +1,2 @@
 #!/bin/sh
-SRCDIR=`dirname "${0}"`
-
-export BARNOWL_DATA_DIR="$SRCDIR/perl/"
-export BARNOWL_BIN_DIR="$SRCDIR/"
-
-HARNESS_PERL=./tester exec prove t/
+HARNESS_PERL=./perl_tester exec prove t/
Index: t/00-core-tests.t
===================================================================
--- t/00-core-tests.t	(revision 95414bfd3960e215dd54e6916a12f56abbf0c820)
+++ t/00-core-tests.t	(revision 1cf3f8d3cf08ed3fb38d1c83459a1db140cb0d17)
@@ -1,3 +1,3 @@
 #!/usr/bin/env perl
 use File::Basename;
-system(dirname($0) . "/../tester", "--builtin");
+system(dirname($0) . "/../tester");
Index: t/mock.pl
===================================================================
--- t/mock.pl	(revision 5aa33fd73dce2c8d6c88559e62cd1ae78ef4a36d)
+++ t/mock.pl	(revision 42ad91716a0f429f02385235acffa71546e28caa)
@@ -1,10 +1,25 @@
+use File::Basename;
+use lib (dirname($0) . '/../perl/lib');
+
 package BarnOwl;
 use strict;
 use warnings;
+use Carp;
 
-no warnings 'redefine';
-sub debug($) {
+sub get_data_dir {"."}
+sub get_config_dir {"."}
+sub create_style {}
+
+sub debug {
     warn "[DEBUG] ", shift, "\n" if $ENV{TEST_VERBOSE};
 }
 
+sub BarnOwl::Internal::new_command {}
+sub BarnOwl::Internal::new_variable_bool {}
+sub BarnOwl::Internal::new_variable_int {}
+sub BarnOwl::Internal::new_variable_string {}
+sub BarnOwl::Editwin::save_excursion(&) {}
+
+use BarnOwl;
+
 1;
Index: ster
===================================================================
--- tester	(revision de18326f12c18fd92f275bf46bca509343b79063)
+++ 	(revision )
@@ -1,1 +1,0 @@
-barnowl
Index: tester.c
===================================================================
--- tester.c	(revision 95414bfd3960e215dd54e6916a12f56abbf0c820)
+++ tester.c	(revision 3f6555d9e7121e9d0551b2f945cfd93e4a2b5040)
@@ -1,18 +1,10 @@
-#define OWL_PERL
-#define WINDOW FAKE_WINDOW
 #include "owl.h"
-#undef WINDOW
-
 #include <unistd.h>
 #include <stdlib.h>
 
-#undef instr
-#include <curses.h>
-
 owl_global g;
 
 int numtests;
 
-int owl_regtest(void);
 int owl_util_regtest(void);
 int owl_dict_regtest(void);
@@ -22,77 +14,13 @@
 int owl_editwin_regtest(void);
 
-extern void owl_perl_xs_init(pTHX);
-
 int main(int argc, char **argv, char **env)
 {
-  FILE *rnull;
-  FILE *wnull;
-  char *perlerr;
-  int status = 0;
-
-  if (argc <= 1) {
-    fprintf(stderr, "Usage: %s --builtin|TEST.t|-le CODE\n", argv[0]);
-    return 1;
-  }
-
   /* initialize a fake ncurses, detached from std{in,out} */
-  wnull = fopen("/dev/null", "w");
-  rnull = fopen("/dev/null", "r");
+  FILE *rnull = fopen("/dev/null", "r");
+  FILE *wnull = fopen("/dev/null", "w");
   newterm("xterm", wnull, rnull);
   /* initialize global structures */
   owl_global_init(&g);
 
-  perlerr = owl_perlconfig_initperl(NULL, &argc, &argv, &env);
-  if (perlerr) {
-    endwin();
-    fprintf(stderr, "Internal perl error: %s\n", perlerr);
-    status = 1;
-    goto out;
-  }
-
-  owl_global_complete_setup(&g);
-  owl_global_setup_default_filters(&g);
-
-  owl_view_create(owl_global_get_current_view(&g), "main",
-                  owl_global_get_filter(&g, "all"),
-                  owl_global_get_style_by_name(&g, "default"));
-
-  owl_function_firstmsg();
-
-  ENTER;
-  SAVETMPS;
-
-  if (strcmp(argv[1], "--builtin") == 0) {
-    status = owl_regtest();
-  } else if (strcmp(argv[1], "-le") == 0 && argc > 2) {
-    /*
-     * 'prove' runs its harness perl with '-le CODE' to get some
-     * information out.
-     */
-    moreswitches("l");
-    eval_pv(argv[2], true);
-  } else {
-    sv_setpv(get_sv("0", false), argv[1]);
-    sv_setpv(get_sv("main::test_prog", TRUE), argv[1]);
-
-    eval_pv("do $main::test_prog; die($@) if($@)", true);
-  }
-
-  status = 0;
-
-  FREETMPS;
-  LEAVE;
-
- out:
-  perl_destruct(owl_global_get_perlinterp(&g));
-  perl_free(owl_global_get_perlinterp(&g));
-  /* probably not necessary, but tear down the screen */
-  endwin();
-  fclose(rnull);
-  fclose(wnull);
-  return status;
-}
-
-int owl_regtest(void) {
   numtests = 0;
   int numfailures=0;
@@ -110,4 +38,9 @@
   }
   printf("1..%d\n", numtests);
+
+  /* probably not necessary, but tear down the screen */
+  endwin();
+  fclose(rnull);
+  fclose(wnull);
 
   return(numfailures);
Index: zcrypt.c
===================================================================
--- zcrypt.c	(revision 3c2c7fc157943127dac6b1c438a38607139dccba)
+++ zcrypt.c	(revision 60fcd71f8988494c502d1533cd073473759ca198)
@@ -88,6 +88,6 @@
 
 cipher_pair ciphers[NCIPHER] = {
-  [CIPHER_DES] = { do_encrypt_des, do_decrypt_des},
-  [CIPHER_AES] = { do_encrypt_aes, do_decrypt_aes},
+  [CIPHER_DES] { do_encrypt_des, do_decrypt_des},
+  [CIPHER_AES] { do_encrypt_aes, do_decrypt_aes},
 };
 
@@ -113,4 +113,6 @@
   int mode = M_NONE;
 
+  extern int optind, opterr;
+  extern char *optarg;
   char c;
 
Index: zephyr.c
===================================================================
--- zephyr.c	(revision 987cf3f48057443b84ecf140854129cf1a6cbbdc)
+++ zephyr.c	(revision 922f5890c367ee59369356b3b41d2399001bbf05)
@@ -852,5 +852,4 @@
   char *tmpbuff, *myuser, *to;
   owl_message *mout;
-  owl_zwrite *z;
   
   /* bail if it doesn't look like a message we should reply to.  Some
@@ -888,13 +887,8 @@
   owl_free(to);
 
-  z = owl_zwrite_new(tmpbuff);
-  owl_zwrite_set_message(z, owl_global_get_zaway_msg(&g));
-  owl_zwrite_set_zsig(z, "Automated reply:");
-
   /* display the message as an admin message in the receive window */
-  mout=owl_function_make_outgoing_zephyr(z);
+  mout=owl_function_make_outgoing_zephyr(owl_global_get_zaway_msg(&g), tmpbuff, "Automated reply:");
   owl_global_messagequeue_addmsg(&g, mout);
   owl_free(tmpbuff);
-  owl_zwrite_delete(z);
 #endif
 }
Index: zwrite.c
===================================================================
--- zwrite.c	(revision 7bfc61380289737bd52f9cae9175a60839766b6a)
+++ zwrite.c	(revision c230bc1b418cbace9d748df62640c26a59aa1622)
@@ -5,14 +5,4 @@
 #include "owl.h"
 
-owl_zwrite *owl_zwrite_new(const char *line)
-{
-  owl_zwrite *z = owl_malloc(sizeof *z);
-  if (owl_zwrite_create_from_line(z, line) < 0) {
-    owl_zwrite_delete(z);
-    return NULL;
-  }
-  return z;
-}
-
 int owl_zwrite_create_from_line(owl_zwrite *z, const char *line)
 {
@@ -25,5 +15,4 @@
   
   /* start with null entries */
-  z->cmd=NULL;
   z->realm=NULL;
   z->class=NULL;
@@ -46,5 +35,4 @@
   myargc=argc;
   if (myargc && *(myargv[0])!='-') {
-    z->cmd=owl_strdup(myargv[0]);
     myargc--;
     myargv++;
@@ -199,11 +187,4 @@
 }
 
-/* Set the message with no post-processing*/
-void owl_zwrite_set_message_raw(owl_zwrite *z, const char *msg)
-{
-  if (z->message) owl_free(z->message);
-  z->message = owl_validate_utf8(msg);
-}
-
 void owl_zwrite_set_message(owl_zwrite *z, const char *msg)
 {
@@ -369,10 +350,4 @@
 }
 
-void owl_zwrite_delete(owl_zwrite *z)
-{
-  owl_zwrite_cleanup(z);
-  owl_free(z);
-}
-
 void owl_zwrite_cleanup(owl_zwrite *z)
 {
